# gives all the good effects
effect give @a regeneration 999999 255 true
effect give @a saturation 999999 255 true

# runs functions that needs to run every tick
function datapack:falling
execute as @a at @s run attribute @s generic.attack_damage base set 0 

# if someone is in lava kills them
execute as @a at @s if block ~0.3 ~0 ~0.3 minecraft:lava run function datapack:death1
execute as @a at @s if block ~0.3 ~0 ~-0.3 minecraft:lava run function datapack:death1
execute as @a at @s if block ~-0.3 ~0 ~0.3 minecraft:lava run function datapack:death1
execute as @a at @s if block ~-0.3 ~0 ~-0.3 minecraft:lava run function datapack:death1

# checks if you drop the apple and resets you if you did
execute as @a at @s if entity @e[type=item,nbt={Item:{id:"minecraft:apple"}}] run function datapack:death1
execute as @a at @s if entity @e[type=item,nbt={Item:{id:"minecraft:apple"}}] run kill @e[type=item,nbt={Item:{id:"minecraft:apple"}}]

# makes farm land untramplable in level 2
fill 2 9 141 3 9 148 minecraft:farmland[moisture=7]
fill 5 9 141 6 9 148 minecraft:farmland[moisture=7]

# gives iron and flint in level 5
execute as @a at @s if entity @s[x=2,y=27,z=226,dx=0,dy=1,dz=0] run execute unless entity @s[nbt={Inventory:[{id:"minecraft:flint_and_steel"}]}] run execute unless entity @s[nbt={Inventory:[{id:"minecraft:iron_ingot"}]}] run give @a iron_ingot
kill @e[type=item,nbt={Item:{id:"minecraft:iron_ingot"}}]
execute as @a at @s if entity @s[x=8,y=26,z=234,dx=0,dy=1,dz=0] run execute unless entity @s[nbt={Inventory:[{id:"minecraft:flint_and_steel"}]}] run execute unless entity @s[nbt={Inventory:[{id:"minecraft:flint"}]}] run give @a flint
kill @e[type=item,nbt={Item:{id:"minecraft:flint"}}]

#fixes trapdoors in level 6
fill -1 12 262 0 12 262 minecraft:warped_trapdoor[open=true,facing=south,half=top]

# removes other iron and flint in your inventory if you have the flint and steel
execute as @a at @s if entity @s[nbt={Inventory:[{id:"minecraft:flint_and_steel"}]}] run clear @s flint
execute as @a at @s if entity @s[nbt={Inventory:[{id:"minecraft:flint_and_steel"}]}] run clear @s iron_ingot

# suggests making a flint and steel in level 5
execute as @a at @s if block -12 21 212 stone if entity @s[x=-7,y=22,z=229,dx=5,dy=5,dz=5] run tellraw @a [{"text": "<"},{"selector":"@s"},{"text": "> I should probably get a flint and steel to light the portal"}]
execute as @a at @s if block -12 21 212 stone if entity @s[x=-7,y=22,z=229,dx=5,dy=5,dz=5] run setblock -12 21 212 air

# starts the portal in level 5
execute as @a at @s if entity @s[x=-7,y=22,z=229,dx=5,dy=5,dz=5,nbt={Inventory:[{id:"minecraft:flint_and_steel"}]}] run fill -4 23 232 -5 25 232 minecraft:nether_portal
execute as @a at @s if entity @s[x=-7,y=22,z=229,dx=5,dy=5,dz=5,nbt={Inventory:[{id:"minecraft:flint_and_steel"}]}] run clear @a flint_and_steel

# tp you to the other side of the portal if it is active in level 5
execute if block -5 23 232 nether_portal run execute as @a at @s if entity @s[x=-5,y=23,z=232,dx=1,dy=2,dz=0] run tp @a -6 13 227.0 -90 0
execute if block -8 13 226 nether_portal run execute as @a at @s if entity @s[x=-8,y=13,z=226,dx=0,dy=2,dz=1] run tp @a -4.0 22 231 180 0

# tp you to the other side of the portal if it is active in level 8
execute if block 5 -10 297 nether_portal run execute as @a at @s if entity @s[x=5,y=-10,z=297,dx=0,dy=2,dz=1] run tp @a 2.0 5 317 180 0
execute if block 1 5 318 nether_portal run execute as @a at @s if entity @s[x=1,y=5,z=318,dx=1,dy=2,dz=0] run tp @a 6 -11 298.0 -90 0

# gives the sword in level 10 if you are close enough
execute as @a[x=-14,y=19,z=397,dx=0,dy=1,dz=0] at @s run execute unless entity @s[nbt={Inventory:[{id:"minecraft:iron_sword"}]}] run fill -14 19 397 -14 20 397 air
execute as @a[x=-14,y=19,z=397,dx=0,dy=1,dz=0] at @s run execute unless entity @s[nbt={Inventory:[{id:"minecraft:iron_sword"}]}] run give @s iron_sword{Unbreakable:1,display:{Name:'[{"text":"Dragon Slayer","italic":false,"color":"dark_red","bold":true}]',Lore:['[{"text":"Killed The Mother Of All Dragons","italic":false,"color":"gray"}]']},Enchantments:[{}],HideFlags:4} 1
kill @e[type=item,nbt={Item:{id:"minecraft:iron_sword"}}]

# kills the dragon if you get close to it
execute as @a[x=-14,y=23,z=382,dx=0,dy=1,dz=0,nbt={Inventory:[{id:"minecraft:iron_sword"}]}] at @s run kill @e[type=ender_dragon]
execute as @a[x=-14,y=23,z=382,dx=0,dy=1,dz=0,nbt={Inventory:[{id:"minecraft:iron_sword"}]}] at @s run schedule function datapack:win 10s
execute as @a[x=-14,y=23,z=382,dx=0,dy=1,dz=0,nbt={Inventory:[{id:"minecraft:iron_sword"}]}] at @s run playsound entity.ender_dragon.death hostile @a -14 23 382 99999999999
execute as @a[x=-14,y=23,z=382,dx=0,dy=1,dz=0,nbt={Inventory:[{id:"minecraft:iron_sword"}]}] at @s run clear @a iron_sword

# wins the map if you beat the super secret level
execute as @a[x=46,y=30,z=-19,dx=0,dy=1,dz=0] at @s run function datapack:secret_win

# kills you if you fall off the end island
execute as @a at @s if entity @s[x=-39,y=0,z=352,dx=51,dy=1,dz=51] run function datapack:death1

# fixes the end dragon when you win the game
execute as @a at @s if entity @s[x=-4,y=31,z=0,dx=0,dy=1,dz=0] run kill @e[type=ender_dragon]

# makes all the signs of the secret levels red or green depending on if you've completed them
execute if score desert secret matches 1 run clone -4 28 2 -4 28 2 -4 31 2
execute if score desert secret matches 0 run clone -4 27 2 -4 27 2 -4 31 2

execute if score bee_hive secret matches 1 run clone -2 28 2 -2 28 2 -2 31 2
execute if score bee_hive secret matches 0 run clone -2 27 2 -2 27 2 -2 31 2

execute if score slime_chunk secret matches 1 run clone 0 28 2 0 28 2 0 31 2
execute if score slime_chunk secret matches 0 run clone 0 27 2 0 27 2 0 31 2

execute if score deep_dark_caves secret matches 1 run clone 2 28 2 2 28 2 2 31 2
execute if score deep_dark_caves secret matches 0 run clone 2 27 2 2 27 2 2 31 2

execute if score bastion secret matches 1 run clone 6 28 2 6 28 2 6 31 2
execute if score bastion secret matches 0 run clone 6 27 2 6 27 2 6 31 2

execute if score blaze_spawner secret matches 1 run clone 8 28 2 8 28 2 8 31 2
execute if score blaze_spawner secret matches 0 run clone 8 27 2 8 27 2 8 31 2

execute if score pillager_outpost secret matches 1 run clone 12 28 2 12 28 2 12 31 2
execute if score pillager_outpost secret matches 0 run clone 12 27 2 12 27 2 12 31 2

# unlocks the super secret level if you won all the other ssecrets
execute if score desert secret matches 1 if score bee_hive secret matches 1 if score slime_chunk secret matches 1 if score deep_dark_caves secret matches 1 if score bastion secret matches 1 if score blaze_spawner secret matches 1 if score pillager_outpost secret matches 1 run setblock 18 32 0 light

# go to credits room from main room
execute if block 0 6 -3 acacia_button[powered=true] run tp @a 0 5 -100 180 0
execute if block 0 6 -3 acacia_button[powered=true] run setblock 0 6 -3 acacia_button[facing=south]

# go to main room from credits room
execute if block 0 6 -95 acacia_button[powered=true] run tp @a 0 5 0 0 0
execute if block 0 6 -95 acacia_button[powered=true] run setblock 0 6 -95 acacia_button

# shows rules
execute if block -3 6 0 acacia_button[powered=true] run tellraw @a {"text": "","color": "white"}
execute if block -3 6 0 acacia_button[powered=true] run tellraw @a [{"text": "[","color": "white"},{"text": "Rules","color": "dark_red"},{"text": "] Players Recommended: 1","color": "white"}]
execute if block -3 6 0 acacia_button[powered=true] run tellraw @a [{"text": "[","color": "white"},{"text": "Rules","color": "dark_red"},{"text": "] Stay in Adventure mode unless my map sucks and you need to fix it","color": "white"}]
execute if block -3 6 0 acacia_button[powered=true] run tellraw @a [{"text": "[","color": "white"},{"text": "Rules","color": "dark_red"},{"text": "] There are some secret levels spread throughout the map but if you don't like exploring you can play all of them at the end, using the level select","color": "white"}]
execute if block -3 6 0 acacia_button[powered=true] run tellraw @a [{"text": "[","color": "white"},{"text": "Rules","color": "dark_red"},{"text": "] This map is challenging so good luck, and have fun!","color": "white"}]
execute if block -3 6 0 acacia_button[powered=true] run setblock -3 6 0 minecraft:acacia_button[facing=east]

# starting the map / tutorial
execute if block 0 6 3 acacia_button[powered=true] run clear @a
execute if block 0 6 3 acacia_button[powered=true] run effect give @a invisibility 999999 255 true
execute if block 0 6 3 acacia_button[powered=true] run setblock 16 28 96 redstone_block
execute if block 16 28 96 redstone_block run tp @a -1 29 94 -90 90
execute if block 16 28 96 redstone_block run gamemode spectator @a
execute if block 16 28 94 redstone_block run tp @a 5 12 93 -80.35 30.90
execute if block 16 28 92 redstone_block run tp @a -11 13 94 -90 25
execute if block 0 6 3 acacia_button[powered=true] run tellraw @a [{"text": "<","color": "white"},{"text": "Tutorial","color": "blue"},{"text": "> ","color": "white"},{"text": "Your goal is to beat the game so you must parkour through minecraft to kill the Enderdragon!","color": "white"}]
execute if block 0 6 3 acacia_button[powered=true] run schedule function datapack:levels/tutorial1 6s
execute if block 0 6 3 acacia_button[powered=true] run schedule function datapack:levels/tutorial2 12s
execute if block 0 6 3 acacia_button[powered=true] run schedule function datapack:levels/tutorial3 22s
execute if block 0 6 3 acacia_button[powered=true] run setblock 0 6 3 acacia_button[facing=north]

# going to level 1
execute as @a at @s if entity @s[x=11,y=10,z=94,dx=0,dy=1,dz=0] run execute as @a at @s run playsound block.ender_chest.open master @s ~ ~ ~ 99999999999999999999 2
execute as @a at @s if entity @s[x=11,y=10,z=94,dx=0,dy=1,dz=0] run execute as @a at @s run playsound minecraft:block.note_block.pling master @s ~ ~ ~ 99999999999999999999 1.7
execute as @a at @s if entity @s[x=11,y=10,z=94,dx=0,dy=1,dz=0] run execute as @a at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 99999999999999999999 2
execute as @a at @s if entity @s[x=11,y=10,z=94,dx=0,dy=1,dz=0] run schedule function datapack:levels/level0 3s replace
execute as @a at @s if entity @s[x=11,y=10,z=94,dx=0,dy=1,dz=0] run schedule function datapack:levels/level1 7s replace
execute as @a at @s if entity @s[x=11,y=10,z=94,dx=0,dy=1,dz=0] run title @a title [{"text": "P","color": "dark_red"},{"text": "i","color": "red"},{"text": "x","color": "gold"},{"text": "e","color": "yellow"},{"text": "l","color": "dark_green"},{"text": "_","color": "dark_gray"},{"text": "G","color": "green"},{"text": "a","color": "aqua"},{"text": "m","color": "dark_aqua"},{"text": "e","color": "blue"},{"text": "r","color": "dark_blue"},{"text": "5","color": "light_purple"},{"text": "9","color": "dark_purple"}]
execute as @a at @s if entity @s[x=11,y=10,z=94,dx=0,dy=1,dz=0] run title @a subtitle {"text": "Presents","color": "white"}
execute as @a at @s if entity @s[x=11,y=10,z=94,dx=0,dy=1,dz=0] run spawnpoint @a -11 5 123 -135
execute as @a at @s if entity @s[x=11,y=10,z=94,dx=0,dy=1,dz=0] run tp @a -11 5 123 -135 0

# going to level 1b
execute as @a at @s if entity @s[x=12,y=6,z=100,dx=0,dy=1,dz=0] run function datapack:levels/level1b

# winning level 1b
execute as @a at @s if entity @s[x=17,y=24,z=113,dx=0,dy=1,dz=0] run scoreboard players set desert secret 1
execute as @a at @s if entity @s[x=17,y=24,z=113,dx=0,dy=1,dz=0] run execute as @a at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 99999999999999999999 0
execute as @a at @s if entity @s[x=17,y=24,z=113,dx=0,dy=1,dz=0] run title @a title {"text": "Level 1b","color": "white"}
execute as @a at @s if entity @s[x=17,y=24,z=113,dx=0,dy=1,dz=0] run title @a subtitle {"text": "Complete","color": "green"}
execute as @a at @s if entity @s[x=17,y=24,z=113,dx=0,dy=1,dz=0] run spawnpoint @a -11 5 123 -135
execute as @a at @s if entity @s[x=17,y=24,z=113,dx=0,dy=1,dz=0] run tp @a -11 5 123 -135 0

# going to level 2
execute as @a at @s if entity @s[x=4,y=25,z=122,dx=0,dy=1,dz=0] run function datapack:levels/level2

# going to level 2b
execute as @a at @s if entity @s[x=-5,y=5,z=129,dx=0,dy=1,dz=0,y_rotation=-30..30] run function datapack:levels/level2b

# winning level 2b
execute as @a at @s if entity @s[x=17,y=1,z=141,dx=0,dy=1,dz=0] run scoreboard players set bee_hive secret 1
execute as @a at @s if entity @s[x=17,y=1,z=141,dx=0,dy=1,dz=0] run execute as @a at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 99999999999999999999 0
execute as @a at @s if entity @s[x=17,y=1,z=141,dx=0,dy=1,dz=0] run title @a title {"text": "Level 2b","color": "white"}
execute as @a at @s if entity @s[x=17,y=1,z=141,dx=0,dy=1,dz=0] run title @a subtitle {"text": "Complete","color": "green"}
execute as @a at @s if entity @s[x=17,y=1,z=141,dx=0,dy=1,dz=0] run spawnpoint @a 4 25 134 0
execute as @a at @s if entity @s[x=17,y=1,z=141,dx=0,dy=1,dz=0] run tp @a 4 25 134 0 0

# going to level 3
execute as @a at @s if entity @s[x=-11,y=2,z=150,dx=0,dy=1,dz=0] run function datapack:levels/level3

# going to level 3b
execute as @a at @s if entity @s[x=3,y=-5,z=181,dx=0,dy=1,dz=0] run function datapack:levels/level3b

# winning level 3b
execute as @a at @s if entity @s[x=29,y=16,z=162,dx=0,dy=1,dz=0] run scoreboard players set slime_chunk secret 1
execute as @a at @s if entity @s[x=29,y=16,z=162,dx=0,dy=1,dz=0] run execute as @a at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 99999999999999999999 0
execute as @a at @s if entity @s[x=29,y=16,z=162,dx=0,dy=1,dz=0] run title @a title {"text": "Level 3b","color": "white"}
execute as @a at @s if entity @s[x=29,y=16,z=162,dx=0,dy=1,dz=0] run title @a subtitle {"text": "Complete","color": "green"}
execute as @a at @s if entity @s[x=29,y=16,z=162,dx=0,dy=1,dz=0] run spawnpoint @a 10 2 159 30
execute as @a at @s if entity @s[x=29,y=16,z=162,dx=0,dy=1,dz=0] run tp @a 10 2 159 30 20

# going to level 4
execute as @a at @s if entity @s[x=-11,y=-7,z=179,dx=0,dy=1,dz=0] run function datapack:levels/level4

# going to level 4b
execute as @a at @s if entity @s[x=11,y=11,z=189,dx=0,dy=1,dz=0] run function datapack:levels/level4b

# winning level 4b
execute as @a at @s if entity @s[x=29,y=19,z=197,dx=0,dy=1,dz=0] run scoreboard players set deep_dark_caves secret 1
execute as @a at @s if entity @s[x=29,y=19,z=197,dx=0,dy=1,dz=0] run execute as @a at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 99999999999999999999 0
execute as @a at @s if entity @s[x=29,y=19,z=197,dx=0,dy=1,dz=0] run title @a title {"text": "Level 4b","color": "white"}
execute as @a at @s if entity @s[x=29,y=19,z=197,dx=0,dy=1,dz=0] run title @a subtitle {"text": "Complete","color": "green"}
execute as @a at @s if entity @s[x=29,y=19,z=197,dx=0,dy=1,dz=0] run spawnpoint @a 10 17 186 90
execute as @a at @s if entity @s[x=29,y=19,z=197,dx=0,dy=1,dz=0] run tp @a 10 17 186 90 0

# going to level 5
execute as @a at @s if entity @s[x=-11,y=13,z=207,dx=0,dy=1,dz=0] run function datapack:levels/level5

# going to level 6
execute as @a at @s if entity @s[x=11,y=15,z=213,dx=0,dy=1,dz=0] run function datapack:levels/level6

# going to level 6b
execute as @a at @s if entity @s[x=11,y=7,z=240,dx=0,dy=1,dz=0] run function datapack:levels/level6b

# winning level 6b
execute as @a at @s if entity @s[x=29,y=26,z=241,dx=0,dy=1,dz=0] run scoreboard players set bastion secret 1
execute as @a at @s if entity @s[x=29,y=26,z=241,dx=0,dy=1,dz=0] run execute as @a at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 99999999999999999999 0
execute as @a at @s if entity @s[x=29,y=26,z=241,dx=0,dy=1,dz=0] run title @a title {"text": "Level 6b","color": "white"}
execute as @a at @s if entity @s[x=29,y=26,z=241,dx=0,dy=1,dz=0] run title @a subtitle {"text": "Complete","color": "green"}
execute as @a at @s if entity @s[x=29,y=26,z=241,dx=0,dy=1,dz=0] run spawnpoint @a -7 15 241 -90
execute as @a at @s if entity @s[x=29,y=26,z=241,dx=0,dy=1,dz=0] run tp @a -7 15 241 -90 0

# going to level 7
execute as @a at @s if entity @s[x=11,y=20,z=260,dx=0,dy=1,dz=0] run function datapack:levels/level7

# going to level 7b
execute as @a at @s if entity @s[x=2,y=14,z=272,dx=0,dy=1,dz=0] run function datapack:levels/level7b

# winning level 7b
execute as @a at @s if entity @s[x=22,y=23,z=276,dx=0,dy=1,dz=0] run scoreboard players set blaze_spawner secret 1
execute as @a at @s if entity @s[x=22,y=23,z=276,dx=0,dy=1,dz=0] run execute as @a at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 99999999999999999999 0
execute as @a at @s if entity @s[x=22,y=23,z=276,dx=0,dy=1,dz=0] run title @a title {"text": "Level 7b","color": "white"}
execute as @a at @s if entity @s[x=22,y=23,z=276,dx=0,dy=1,dz=0] run title @a subtitle {"text": "Complete","color": "green"}
execute as @a at @s if entity @s[x=22,y=23,z=276,dx=0,dy=1,dz=0] run spawnpoint @a -8 20 288 -90
execute as @a at @s if entity @s[x=22,y=23,z=276,dx=0,dy=1,dz=0] run tp @a -8 20 288 -90 0

# going to level 8
execute as @a at @s if entity @s[x=11,y=13,z=272,dx=0,dy=1,dz=0] run function datapack:levels/level8

# going to level 9
execute as @a at @s if entity @s[x=-3,y=18,z=301,dx=0,dy=1,dz=0] run function datapack:levels/level9

# going to level 9b
execute as @a at @s if entity @s[x=-12,y=5,z=328,dx=0,dy=1,dz=0] run function datapack:levels/level9b

# winning level 9b
execute as @a at @s if entity @s[x= 23,y=19,z=336,dx=0,dy=1,dz=0] run scoreboard players set pillager_outpost secret 1
execute as @a at @s if entity @s[x= 23,y=19,z=336,dx=0,dy=1,dz=0] run execute as @a at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 99999999999999999999 0
execute as @a at @s if entity @s[x= 23,y=19,z=336,dx=0,dy=1,dz=0] run title @a title {"text": "Level 9b","color": "white"}
execute as @a at @s if entity @s[x= 23,y=19,z=336,dx=0,dy=1,dz=0] run title @a subtitle {"text": "Complete","color": "green"}
execute as @a at @s if entity @s[x= 23,y=19,z=336,dx=0,dy=1,dz=0] run spawnpoint @a -3 18 346 180
execute as @a at @s if entity @s[x= 23,y=19,z=336,dx=0,dy=1,dz=0] run tp @a -3 18 346 180 0

# going to level 10
execute as @a at @s if entity @s[x=32,y=-47,z=363,dx=4,dy=1,dz=4] run function datapack:levels/level10